<template>
<div class="container mt-3">
    <div class="row">
        <div class="col-9 mx-auto">
            <div class="card">
                <h5 class="card-header text-center gray-bg">Result Search:</h5>
                    <div class="card-body ">
                        <h5 class="card-title text-center">Special title treatment</h5>
                        <div class="card-body">
                            <table class="table table-bordered table-striped">
                                <thead class="text-center">
                                    <tr>
                                        <th v-for="(key , index) in columns" :key="index"
                                        @click="sortBy(key)"
                                        :class="{ active: sortKey == key }">
                                        {{ key | capitalize}}
                                        <span class="arrow" :class="sortOrders[key] > 0 ?'asc': 'dsc'"></span>
                                        </th>
                                    </tr>
                                </thead>
                                <tbody class="text-center">
                                    <tr v-for="(entry , index) in filteredData" :key="index">
                                        <td v-for="(key , index) in columns" :key="index" >
                                            {{ entry[key] }}
                                        </td>
                                    </tr>
                                </tbody>
                        </table>
                        </div>
                        <a href="#" class="btn btn-primary">Go somewhere</a>
                    </div>
            </div>
        </div>
    </div>
</div>
    
</template>
<script>
export default {
    props:{
        data:Array,
        columns:Array,
        filterKey:String
    },
    data() {
        let sortOrders ={};
        this.columns.forEach(key => {
            sortOrders[key] = 1;
        });
        return {
            sortKey:'',
            sortOrders:sortOrders
        }
    },
    computed: {
        filteredData(){
            let sortKey = this.sortKey;
            let filterKey = this.filterKey && this.filterKey.toLowerCase();
            let order = this.sortOrders[sortKey] || 1;
            let data = this.data;
            if (filterKey) {
                data = data.filter( (row)=>{
                    return Object.keys(row).some((key)=>{
                        return String(row[key]).toLowerCase().indexOf(filterKey) > -1;
                    })
                })
            }
            if (sortKey) {
                data = data.slice().sort((a,b)=>{
                    a = a[sortKey];
                    b = b[sortKey];
                    return ( a === b ? 0:a > b ? 1 : -1) * order;
                })
            }
            return data;

        },
    },
    filters:{
        capitalize: (str)=>{
            return str.charAt(0).toUpperCase() + str.slice(1);
        }
    },
    methods: {
        sortBy:(key)=>{
            this.sortKey = key;
            this.sortOrders[key] = this.sortOrders[key] * -1;
        }
    },
}
</script>
<style lang="">
    
</style>